------------------------------------------------------------
-- Initialization, nothing to be changed.

wanted = {}
kills = {}
query_timer = {}
warned = {}

------------------------------------------------------------
-- Settings, change it if you want to.

killscode = -- set the color here
{
	[1] = "pale grey";
	[2] = "dark grey";
	[3] = "yellow";
	[4] = "orange";
	["MAX!"] = "red"; -- color for players reaching upper limit
}
kills_upperlimit = 4 -- Most dangerous players D:
wantedlist_title_color = "cyan" -- color for "Wanted List:" title.
wantedlist_default = "yellow" -- color for default message.
time_span = 5 -- Duration until next query
maximum_warn = 3 -- BEGONE SPAMMERS!
check_team = 1 -- which team to be added to the list?

------------------------------------------------------------
-- These are main codes.

addhook("spawn", "_ons")
addhook("kill", "_onk")
addhook("serveraction", "_sva")
addhook("second", "_sec")
addhook("leave", "_onl")

function _sec()
	for _, i in pairs(player(0, "tableliving")) do
		if query_timer[i] > 0 then
			query_timer[i] = query_timer[i] - 1
		else
			query_timer[i] = 0
		end
	end
end

function removing(t, n)
	if next(t) then
		for i = 1, #t do
			if t[i] == n then
				table.remove(t, i)
				break
			end
		end
	end
end

function checkteam(p)
	if check_team == 1 then
		if player(p, "team") == 3 then
			return 3
		else
			return 2
		end
	else
		return 1
	end
end


function _onk(k, v)
	local enemyt = checkteam(k)
	if player(k, "team") == check_team then
		kills[k] = kills[k] + 1
		if not wanted[k] then
			table.insert(wanted, k)
		end
	elseif player(k, "team") == enemyt and player(v, "team") == check_team then
		removing(wanted, v)
	end
end

function initplayer(p)
	if player(p, "team") == check_team then
		kills[p] = 0
		removing(wanted, p)
	end
	query_timer[p] = 0
	warned[p] = 0
end

function _ons(id)
	initplayer(id)
end

function _onl(p)
	initplayer(p)
end

function checkwarn(p)
	warned[p] = warned[p] + 1
	if warned[p] <= maximum_warn then
		msg2(p, "\169"..color_code["red"].."You must wait for "..query_timer[p].." seconds to see the list again!")
		msg2(p, "\169"..color_code["white"].."Spamming the serveraction icon makes you kicked!") 
	else
		parse("kick "..p..'\"Abusing serveraction"')
	end
end

function _sva(id, a)
	if a == 1 then
		if query_timer[id] > 0 then checkwarn(id) return end
		query_timer[id] = time_span
		msg2(id, "\169"..color_code[wantedlist_title_color].."Wanted List:")
		if not next(wanted) then
			msg2(id, "\169"..color_code[wantedlist_default].."No wanted players!")
			return
		end
		for _, x in ipairs(wanted) do
			if kills[x] <= kills_upperlimit then
				msg2 (id, "\169"..color_code[killscode[kills[x]]]..player(x, "name").."\169"..color_code[wantedlist_default].." #Kills: \169"..color_code[killscode[kills[x]]]..kills[x]) 
			else
				msg2 (id, "\169"..color_code[killscode["MAX!"]]..player(x, "name").."\169"..color_code[wantedlist_default].." #Kills: \169"..color_code["MAX!"]..kills[x])
			end
		end
	end
end

------------------------------------------------------------